/******************************************************************************

	File:	MediaDefs.h

	Copyright 1995-97, Be Incorporated

	PATCHED -- HOOK RM 151198 for R4b4

******************************************************************************/
#ifndef _R3_MEDIA_DEFS_H
#define _R3_MEDIA_DEFS_H


#include <Subscriber.h>
#include <AudioStream.h>
#include <BufferStreamManager.h>

#include <SupportDefs.h>
#include <Errors.h>

/* Buffer header for audio server */

typedef struct r3_audio_buffer_header {
  int32 buffer_number;
  int32 subscriber_count;
  bigtime_t time;
  int32 reserved_1;
  int32 reserved_2;
  int32 reserved_3;
  int32 reserved_4;
} audio_buffer_header;


#define		R3_B_MEDIA_LEVEL	B_REAL_TIME_PRIORITY

#define 	R3_B_NO_CHANGE (-1)

/* ================
   Subscriber IDs and special values
   ================ */

#define			R3_B_NO_SUBSCRIBER_ID		((subscriber_id)-1)
#define			R3_B_NO_SUBSCRIBER_NAME		"not subscribed"

#define			R3_B_SHARED_SUBSCRIBER_ID	((subscriber_id)-2)
#define			R3_B_SHARED_SUBSCRIBER_NAME	"shared subscriber"

/* ================
   Values for sound files and audio streams 
   ================ */

/* values for byte_ordering */
enum { R3_B_BIG_ENDIAN, R3_B_LITTLE_ENDIAN };

/* values for sample_format */
enum { 
  R3_B_UNDEFINED_SAMPLES,
  R3_B_LINEAR_SAMPLES,
  R3_B_FLOAT_SAMPLES,
  R3_B_MULAW_SAMPLES
  };

/* Audio device codes for BAudioSubscriber's
 * Get/SetVolume() and EnableDevice() calls 
 */
enum  {
	R3_B_CD_THROUGH=0,
	R3_B_LINE_IN_THROUGH,
	R3_B_ADC_IN,
	R3_B_LOOPBACK,
	R3_B_DAC_OUT,
	R3_B_MASTER_OUT,
	R3_B_SPEAKER_OUT,
	R3_B_SOUND_DEVICE_END
  };

/* ADC input codes */
enum {
	R3_B_CD_IN,
	R3_B_LINE_IN,
	R3_B_MIC_IN 
  };


enum {
  R3_B_DAC_STREAM = 2354,
  R3_B_ADC_STREAM
  };

#endif	// #ifndef _R3_MEDIA_DEFS_H
